/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jsr308.annotations.on.java.types;

import java.lang.annotation.ElementType;
import java.lang.annotation.Target;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;

/**
 *
 * @author mstoynov
 */
public class JSR308Example4 {

}

@Target(ElementType.TYPE)
@interface DefaultQualifier{
    String value() default "";
}

@Target(ElementType.TYPE_USE)
@interface Interned{
    String value() default "";
}

class Vertex{}
abstract class Edge {
    abstract Vertex from();
    abstract Vertex to();
}

@DefaultQualifier("NonNull")
 class DAG {
   Set<Edge> edges;
   // ...

   List<Vertex> getNeighbors(@Interned @Readonly Vertex v) @Readonly {
     List<Vertex> neighbors = new LinkedList<Vertex>();
     for (Edge e : edges)
       if (e.from() == v)
         neighbors.add(e.to());
     return neighbors;
  }
}