/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package project.coin;

import java.dyn.MethodHandle;
import java.dyn.MethodHandles;
import java.dyn.MethodType;
import java.io.PrintStream;

public class E7_LanguageSupportForJSR292 {
    // Because of warnings.

    private static PrintStream out = System.out;

    /** WORKING in b89 */
    public static void languageSupportForJSR292() throws Throwable {

        // 1. java.dyn.Dynamic will accept any method call
        // THE OLD WAY: no old way
        // THE NEW WAY (COMMENTED BECAUSE NOT IMPLEMENTED YET)
//        boolean z = java.dyn.InvokeDynamic.<boolean>myEquals(x, y);  // type (Object, int) -> boolean

        // 2. The type java.dyn.MethodHandle will accept any argument and return types
        // -- for a call to the method named invoke, which means that Java code can spell
        // -- the full range of method handle invocations.
        // THE OLD WAY: reflection?
        // THE NEW WAY
        MethodHandle handle = MethodHandles.lookup().findVirtual(
                PrintStream.class, "println", MethodType.methodType(void.class, String.class));
        handle.invokeGeneric(System.out, "holy cow?!");

        // 3.The full range of bytecode names acceptable to the JVM can be spelled from
        // --Java code, using an exotic identifier quoting syntax
        // THE OLD WAY: reflection?
        // THE NEW WAY:
//        String #"g 1 $!$#%" = "Text";
//        System.out.println(#"g 1 $!$#%");
    }
}
